module 4-Inequality where

open import Prelude

-- What do we mean when we say m ≤ n?

data _≤_ : ℕ → ℕ → Set where
  z≤n : ∀ {n}                 → zero  ≤ n
  s≤s : ∀ {m n} (m≤n : m ≤ n) → suc m ≤ suc n

-- We declare a datatype capturing the two rules of m ≤ n.
-- This is like adding axioms into your logic.

-- Let us try proving some properties.

≤-refl : (n : ℕ) → n ≤ n
≤-refl zero = z≤n
≤-refl (suc n) = s≤s (≤-refl n)

≤-trans : (m n k : ℕ) → m ≤ n → n ≤ k → m ≤ k
≤-trans zero n k z≤n n≤k = z≤n 
≤-trans (suc m) (suc n) (suc k) (s≤s m≤n) (s≤s n≤k) = 
     s≤s (≤-trans m n k m≤n n≤k)